• HDU 1078 FatMouse and Cheese


    FatMouse and Cheese

    Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
    Total Submission(s): 6782    Accepted Submission(s): 2789


    Problem Description
    FatMouse has stored some cheese in a city. The city can be considered as a square grid of dimension n: each grid location is labelled (p,q) where 0 <= p < n and 0 <= q < n. At each grid location Fatmouse has hid between 0 and 100 blocks of cheese in a hole. Now he's going to enjoy his favorite food.

    FatMouse begins by standing at location (0,0). He eats up the cheese where he stands and then runs either horizontally or vertically to another location. The problem is that there is a super Cat named Top Killer sitting near his hole, so each time he can run at most k locations to get into the hole before being caught by Top Killer. What is worse -- after eating up the cheese at one location, FatMouse gets fatter. So in order to gain enough energy for his next run, he has to run to a location which have more blocks of cheese than those that were at the current hole.

    Given n, k, and the number of blocks of cheese at each grid location, compute the maximum amount of cheese FatMouse can eat before being unable to move.
     

    Input
    There are several test cases. Each test case consists of

    a line containing two integers between 1 and 100: n and k
    n lines, each with n numbers: the first line contains the number of blocks of cheese at locations (0,0) (0,1) ... (0,n-1); the next line contains the number of blocks of cheese at locations (1,0), (1,1), ... (1,n-1), and so on.
    The input ends with a pair of -1's.
     

    Output
    For each test case output in a line the single integer giving the number of blocks of cheese collected.
     

    Sample Input
    3 1 1 2 5 10 11 6 12 12 7 -1 -1
     

    Sample Output
    37
     
    题意是给定一个矩阵,矩阵元素是有权值的东西,且权值在1到100之间。有一个老鼠从(0, 0)出发开始吃东西,但是他每次最多只能跑K步之内,而这货不知厌倦,每次吃还必须得吃更大权值的东西。

    这个题通过每次需要吃更大的东西其实方便了搜索,但是如果一味的搜索而不是利用dp的记忆性搜索显然会超时,所以在搜索的过程中一定要注意已经来到过的点就可以直接返回了。

    搜索没什么难度,注意细节。利用dp[i][j]表示在(i,j)从最后一个点反过来到这个点的最大值

    代码如下:

    /*************************************************************************
    	> File Name: FatMouse_and_Cheese.cpp
    	> Author: Zhanghaoran
    	> Mail: chilumanxi@xiyoulinux.org
    	> Created Time: Wed 28 Oct 2015 04:12:59 PM CST
     ************************************************************************/
    
    #include <iostream>
    #include <algorithm>
    #include <cstring>
    #include <cstdio>
    #include <cstdlib>
    
    using namespace std;
    int dp[110][110];
    int a[110][110];
    int N, K;
    int dir[4][2] = {{1, 0}, {-1, 0}, {0, 1}, {0, -1}};
    
    bool check(int x, int y){
        if(x >= 0 && x < N && y >= 0 && y < N)
            return true;
        else
            return false;
    }
    int DP(int x, int y){
        if(dp[x][y])
            return dp[x][y];
        int Max = 0;
        for(int i  = 0; i < 4; i ++){
            for(int j = 1; j <= K; j ++){
                int tempx = x + j * dir[i][0];
                int tempy = y + j * dir[i][1];
                if(check(tempx, tempy) && a[tempx][tempy] > a[x][y]){
                    int sum = DP(tempx, tempy);
                    if(Max < sum)
                        Max = sum;
                }
            }
        }
    
        dp[x][y] = Max + a[x][y];
        return dp[x][y];
    }
    
    int main(void){
        while(1){
            scanf("%d%d", &N, &K);
            if(N == -1 && K == -1)
                break;
            memset(dp, 0, sizeof(dp));
            for(int i = 0; i < N; i ++){
                for(int j = 0; j < N; j ++){
                    scanf("%d", &a[i][j]);
                }
            }
            printf("%d
    ", DP(0, 0));
        }
    }


  • 相关阅读:
    14使用函数时要特别考虑的问题
    13子程序的参数
    12子程序的名字和长度
    (解决tomcat端口被占用的问题)create[8005]java.net.BindException: Address already in use: JVM_Bind
    纠错记录(Could not open the editor: Android XML Editor cannot process this input.)
    查看端口被占用的进程号然后结束进程(解决端口被进程占用的问题)
    使用java对执行命令行 或 执行bat文件
    ant_0105
    ant 具体命令行展示代码
    ant 关键字和关键语句
  • 原文地址:https://www.cnblogs.com/chilumanxi/p/5136066.html
Copyright © 2020-2023  润新知